  img = IJ.getImage();
  line = img.getRoi();
  if (line==null || !line.isLine())
    IJ.error("Line selection required"); 
  lineWidth = Math.round(line.getStrokeWidth());
  if (lineWidth<1)
     lineWidth = 1;
  bounds = line.getBounds();
  width = bounds.width + lineWidth*2;
  height = bounds.height + lineWidth*2;
  ip2 = new ByteProcessor(img.getWidth(), img.getHeight());
  ip2.setColor(255);
  //line.setLocation(lineWidth, lineWidth);
  //setLineWidth(linewidth);
  radius = lineWidth/2;
  p = line.getFloatPolygon();
  n = p.npoints;
  xv = new Array(4); //vertex points of rectangle will be filled for each line segment
  yv = new Array(4);
  xt = new Array(3); //vertex points of triangle will be filled for each line segment
  yt = new Array(3);
  dx1 = p.xpoints[1]-p.xpoints[0];
  dy1 = p.ypoints[1]-p.ypoints[0];
  l = len(dx1, dy1);
  dx1 = dx1/l;
  dy1 = dy1/l;
  dx0 = dx1;
  dy0 = dy1;
  xfrom = p.xpoints[0];
  yfrom = p.ypoints[0];
  for (i=1; i<n; i++) { //line segment from point i-1 ("from") to point i ("to")
     xto = p.xpoints[i];
     yto = p.ypoints[i];
     if (i<n-1) {
        dx2 = p.xpoints[i+1]-p.xpoints[i];
        dy2 = p.ypoints[i+1]-p.ypoints[i];
        l = len(dx2, dy2);
        dx2 = dx2/l;
        dy2 = dy2/l;
     } else {
        dx2 = dx1;
        dy2 = dy1;
     }
     xv[0] = xfrom+radius*dy1;
     yv[0] = yfrom-radius*dx1;
     xv[1] = xfrom-radius*dy1;
     yv[1] = yfrom+radius*dx1;
     xv[2] = xto-radius*dy1;
     yv[2] = yto+radius*dx1;
     xv[3] = xto+radius*dy1;
     yv[3] = yto-radius*dx1;
     rect = new PolygonRoi(xv, yv, Roi.POLYGON);
     ip2.fill(rect);
     if (i>0) {  //fill triangle to previous line segment
        rightTurn=(dx1*dy0>dx0*dy1);
        xt[0] = xfrom;
        yt[0] = yfrom;
        if (rightTurn) {
           xt[1] = xfrom-radius*dy0;
           yt[1] = yfrom+radius*dx0;
           xt[2] = xfrom-radius*dy1;
           yt[2] = yfrom+radius*dx1;
        } else {  
           xt[1] = xfrom+radius*dy0;
           yt[1] = yfrom-radius*dx0;
           xt[2] = xfrom+radius*dy1;
           yt[2] = yfrom-radius*dx1;
        }
        tiangle = new PolygonRoi(xt, yt, Roi.POLYGON);
        ip2.fill(tiangle);
     }
     dx0 = dx1;
     dy0 = dy1;
     dx1 = dx2;
     dy1 = dy2;
     xfrom = xto;
     yfrom = yto;
  }
  ip2.setThreshold(255, 255, ImageProcessor.NO_LUT_UPDATE);
  tts = new ThresholdToSelection();
  roi2 = tts.convert(ip2);
  if (roi2!=null)
     img.setRoi(roi2);

  function len(dx, dy) {
     return Math.sqrt(dx*dx+dy*dy);
  }
